VERSION 5.00
Begin VB.Form frmMain 
   AutoRedraw      =   -1  'True
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "DirectInput8: Mouse Control"
   ClientHeight    =   4455
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4275
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   297
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   285
   ShowInTaskbar   =   0   'False
   StartUpPosition =   2  'CenterScreen
   Begin VB.Image imgCursor 
      Height          =   480
      Left            =   0
      Picture         =   "frmMain.frx":0000
      Stretch         =   -1  'True
      Top             =   0
      Width           =   480
   End
   Begin VB.Label lblmisc 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Button 7 State: Up"
      Height          =   195
      Index           =   9
      Left            =   120
      TabIndex        =   9
      Top             =   2280
      Width           =   1320
   End
   Begin VB.Label lblmisc 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Button 6 State: Up"
      Height          =   195
      Index           =   8
      Left            =   120
      TabIndex        =   8
      Top             =   2040
      Width           =   1320
   End
   Begin VB.Label lblmisc 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Button 5 State: Up"
      Height          =   195
      Index           =   7
      Left            =   120
      TabIndex        =   7
      Top             =   1800
      Width           =   1320
   End
   Begin VB.Label lblmisc 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Button 4 State: Up"
      Height          =   195
      Index           =   6
      Left            =   120
      TabIndex        =   6
      Top             =   1560
      Width           =   1320
   End
   Begin VB.Label lblmisc 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Button 3 State: Up"
      Height          =   195
      Index           =   5
      Left            =   120
      TabIndex        =   5
      Top             =   1320
      Width           =   1320
   End
   Begin VB.Label lblmisc 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Button 2 State: Up"
      Height          =   195
      Index           =   4
      Left            =   120
      TabIndex        =   4
      Top             =   1080
      Width           =   1320
   End
   Begin VB.Label lblmisc 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Button 1 State: Up"
      Height          =   195
      Index           =   3
      Left            =   120
      TabIndex        =   3
      Top             =   840
      Width           =   1320
   End
   Begin VB.Label lblmisc 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Button 0 State: Up"
      Height          =   195
      Index           =   2
      Left            =   120
      TabIndex        =   2
      Top             =   600
      Width           =   1320
   End
   Begin VB.Label lblmisc 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Mouse Coordinates: [0,0]"
      Height          =   195
      Index           =   1
      Left            =   120
      TabIndex        =   1
      Top             =   360
      Width           =   1770
   End
   Begin VB.Label lblmisc 
      BackStyle       =   0  'Transparent
      Caption         =   "Press [ESC] to free the mouse"
      Height          =   195
      Index           =   0
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   3225
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'##
'##     DESCRIPTION: DirectInput8 - using the Mouse
'##     WRITTEN BY: Jack Hoxley
'##     DATE: 03/08/01
'##
'##     VISIT: http://www.vbexplorer.com/directx4vb/
'##
'##     This sample implements both the polling and event based methods.
'##

Option Explicit

'//Important, only set one of the following 2 to be true.
Private Const UsePollingMethod As Boolean = False
Private Const UseEventMethod As Boolean = True

'//Speed - this is how fast the mouse cursor will move:
Private Const mSpeed As Single = 2 'nb: at higher values, a noticable stair-case effect occurs during diagonal movement...
'//BufferSize - how much data DI will store for us:
Private Const BufferSize As Long = 10 'events

'//Status variables and other stuff :)
Private bRunning As Boolean 'for the polling version, states when we've finished.
Private mPosition As Point  'where the mouse is currently located...

'//The following object definitions are the master controlling
'   units for DirectInput.
Private DX As DirectX8
Private DI As DirectInput8

'//These next two objects are used to access our device (keyboard)
Private DIDevice As DirectInputDevice8

    
'Sleep() - stops our polling loop going too fast ;)
Private Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)


Dim hEvent As Long 'a handle for an event...
Implements DirectXEvent8 'for an event based system we need a callback function

Private Sub DirectXEvent8_DXCallback(ByVal eventid As Long)
On Error GoTo BailOut:

    If Not (eventid = hEvent) Then Exit Sub 'bailout if the msg isn't for us
    
    '//At this point, we know something has happened - and we want to know what it is!!
    
    '0. Any Variables
        Dim DevData(1 To BufferSize) As DIDEVICEOBJECTDATA 'storage for the event data
        Dim nEvents As Long 'how many events have just happened (usually 1)
        Dim I As Long 'looping variables
        
    '1. retrieve the data from the device.
        nEvents = DIDevice.GetDeviceData(DevData, DIGDD_DEFAULT)
        
    '2. loop through all the events
        For I = 1 To nEvents
            Select Case DevData(I).lOfs
                Case DIMOFS_X
                    'the mouse has moved along the X Axis
                    mPosition.x = mPosition.x + (DevData(I).lData * mSpeed)
                    If mPosition.x < 0 Then mPosition.x = 0
                    If mPosition.x > frmMain.ScaleWidth Then mPosition.x = frmMain.ScaleWidth
                    imgCursor.Top = mPosition.y
                    imgCursor.Left = mPosition.x
                    lblmisc(1).Caption = "Mouse Coordinates: [" & mPosition.x & ", " & mPosition.y & "]"
                    
                Case DIMOFS_Y
                    'the mouse has moved along the Y axis
                    mPosition.y = mPosition.y + (DevData(I).lData * mSpeed)
                    If mPosition.y < 0 Then mPosition.y = 0
                    If mPosition.y > frmMain.ScaleHeight Then mPosition.y = frmMain.ScaleHeight
                    imgCursor.Top = mPosition.y
                    imgCursor.Left = mPosition.x
                    lblmisc(1).Caption = "Mouse Coordinates: [" & mPosition.x & ", " & mPosition.y & "]"
                    
                Case DIMOFS_Z
                    'the mouse has moved along the Z axis (not sure what this one means...!)
                    
                Case DIMOFS_BUTTON0
                    'the first (left) button has been pressed
                    lblmisc(2).Caption = "Button 0 State: " & IIf(DevData(I).lData = 0, "Up", "Down")
                    
                Case DIMOFS_BUTTON1
                    'the second (right) button has been pressed
                    lblmisc(3).Caption = "Button 1 State: " & IIf(DevData(I).lData = 0, "Up", "Down")
                    
                Case DIMOFS_BUTTON2
                    'the third (middle usually) button has been pressed
                    lblmisc(4).Caption = "Button 2 State: " & IIf(DevData(I).lData = 0, "Up", "Down")
                    
                Case DIMOFS_BUTTON3
                    lblmisc(5).Caption = "Button 3 State: " & IIf(DevData(I).lData = 0, "Up", "Down")
                    
                Case DIMOFS_BUTTON4
                    lblmisc(6).Caption = "Button 4 State: " & IIf(DevData(I).lData = 0, "Up", "Down")
                    
                Case DIMOFS_BUTTON5
                    lblmisc(7).Caption = "Button 5 State: " & IIf(DevData(I).lData = 0, "Up", "Down")
                    
                Case DIMOFS_BUTTON6
                    lblmisc(8).Caption = "Button 6 State: " & IIf(DevData(I).lData = 0, "Up", "Down")
                    
                Case DIMOFS_BUTTON7
                    lblmisc(9).Caption = "Button 7 State: " & IIf(DevData(I).lData = 0, "Up", "Down")
                    
            End Select
        Next I
    
        DoEvents 'let windows catch up on things...
        
    Exit Sub
BailOut:
    Debug.Print "Error occured whilst processing a message: ", Err.Number, Err.Description
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    If KeyCode = vbKeyEscape Then
        DIDevice.Unacquire
        Unload Me
        End
    End If
End Sub

Private Sub Form_Load()
On Local Error GoTo BailOut:

Me.Show
DoEvents

'//0. Any variables
    Dim DevData(1 To BufferSize) As DIDEVICEOBJECTDATA
    Dim nEvents As Long
    Dim I As Long
    
'//1. Check options.
    If UsePollingMethod And UseEventMethod Then
        MsgBox "You must select only one of the constants before running"
        Unload Me
        End
    End If
    
    
    
'//2. Initialise the selected method
    Set DX = New DirectX8 'must create the object.
    
    Set DI = DX.DirectInputCreate
    Set DIDevice = DI.CreateDevice("guid_SysMouse")
    Call DIDevice.SetCommonDataFormat(DIFORMAT_MOUSE)
    Call DIDevice.SetCooperativeLevel(frmMain.hWnd, DISCL_FOREGROUND Or DISCL_EXCLUSIVE)
  
    ' Set the buffer size
    Dim diProp As DIPROPLONG
    diProp.lHow = DIPH_DEVICE
    diProp.lObj = 0
    diProp.lData = BufferSize
    
    Call DIDevice.SetProperty("DIPROP_BUFFERSIZE", diProp)
        
    If UseEventMethod Then
        'event based requires some extra initialisation
        hEvent = DX.CreateEvent(frmMain)
        DIDevice.SetEventNotification hEvent
    End If
    
    
    
    DIDevice.Acquire 'let DirectX know that we want to use the device now.
    
    
'//3. Start main loop (Polling Only)
    If UsePollingMethod Then
        If Not Err.Number Then bRunning = True 'no errors, clear for takeoff...
        
        Do While bRunning
            '3a. Get the device data
                nEvents = DIDevice.GetDeviceData(DevData, DIGDD_DEFAULT)
            
            '3b. Loop through it all
                For I = 1 To nEvents
                    'this next part is identical to the event based code...
                    Select Case DevData(I).lOfs
                        Case DIMOFS_X
                            'the mouse has moved along the X Axis
                            mPosition.x = mPosition.x + (DevData(I).lData * mSpeed)
                            If mPosition.x < 0 Then mPosition.x = 0
                            If mPosition.x > frmMain.ScaleWidth Then mPosition.x = frmMain.ScaleWidth
                            imgCursor.Top = mPosition.y
                            imgCursor.Left = mPosition.x
                            lblmisc(1).Caption = "Mouse Coordinates: [" & mPosition.x & ", " & mPosition.y & "]"
                            
                        Case DIMOFS_Y
                            'the mouse has moved along the Y axis
                            mPosition.y = mPosition.y + (DevData(I).lData * mSpeed)
                            If mPosition.y < 0 Then mPosition.y = 0
                            If mPosition.y > frmMain.ScaleHeight Then mPosition.y = frmMain.ScaleHeight
                            imgCursor.Top = mPosition.y
                            imgCursor.Left = mPosition.x
                            lblmisc(1).Caption = "Mouse Coordinates: [" & mPosition.x & ", " & mPosition.y & "]"
                            
                        Case DIMOFS_Z
                            'the mouse has moved along the Z axis (not sure what this one means...!)
                            
                        Case DIMOFS_BUTTON0
                            'the first (left) button has been pressed
                            lblmisc(2).Caption = "Button 0 State: " & IIf(DevData(I).lData = 0, "Up", "Down")
                            
                        Case DIMOFS_BUTTON1
                            'the second (right) button has been pressed
                            lblmisc(3).Caption = "Button 1 State: " & IIf(DevData(I).lData = 0, "Up", "Down")
                            
                        Case DIMOFS_BUTTON2
                            'the third (middle usually) button has been pressed
                            lblmisc(4).Caption = "Button 2 State: " & IIf(DevData(I).lData = 0, "Up", "Down")
                            
                        Case DIMOFS_BUTTON3
                            lblmisc(5).Caption = "Button 3 State: " & IIf(DevData(I).lData = 0, "Up", "Down")
                            
                        Case DIMOFS_BUTTON4
                            lblmisc(6).Caption = "Button 4 State: " & IIf(DevData(I).lData = 0, "Up", "Down")
                            
                        Case DIMOFS_BUTTON5
                            lblmisc(7).Caption = "Button 5 State: " & IIf(DevData(I).lData = 0, "Up", "Down")
                            
                        Case DIMOFS_BUTTON6
                            lblmisc(8).Caption = "Button 6 State: " & IIf(DevData(I).lData = 0, "Up", "Down")
                            
                        Case DIMOFS_BUTTON7
                            lblmisc(9).Caption = "Button 7 State: " & IIf(DevData(I).lData = 0, "Up", "Down")
                
                    End Select
                
                Next I
            
            Sleep (20) 'approx 50fps
            DoEvents
        Loop
        
        'if we've gotten to this point, the user has decided to quit
        DIDevice.Unacquire
        Set DIDevice = Nothing
        Set DI = Nothing
        Set DX = Nothing
        Unload Me
        End
    End If

Exit Sub

BailOut:
    MsgBox "Error occured in Form_Load() - ", Err.Number, Err.Description
End Sub

Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
If UsePollingMethod Then
    'we stop windows/vb from automatically closing, and allow our main loop
    'to finish first - as it has some tidying up to do after it's finished...
    bRunning = False 'tell it the loop ends next time around
    Cancel = True 'tell it not to quit the program just yet...
ElseIf UseEventMethod Then
    'if you notice a slight pause when closing (and using event method) it will
    'be this next line; it takes a second to two to process...
    If hEvent <> 0 Then DX.DestroyEvent hEvent
    Set DIDevice = Nothing
    Set DI = Nothing
    Set DX = Nothing
End If
End Sub

